//+------------------------------------------------------------------+
//|                                                    SAR Cross.mq4 |
//|                                                       Gavner     |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Gavner"
#property link      ""

//---- input parameters
extern double Lots=1.0;
extern double timeframe=60;
extern double TrailingStop=15;
extern double Step=0.0082;
extern double Maximum=0.2;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
double SARCurrent, SARPrevious;
int cnt, ticket, total;

SARCurrent=iSAR(Symbol(),timeframe,Step,Maximum,1);
SARPrevious=iSAR(Symbol(),timeframe,Step,Maximum,2);



   total=OrdersTotal();

   if(total<1)                                                 // Iff there are no open orders
   {

   if(AccountFreeMargin()<(1000*Lots))
   {
   Print("Insufficient funds! Free Margin = ", AccountFreeMargin());
   return(0); 
   }

// Check for BUYS
      if(Close[1]>SARCurrent && Close[2] < SARPrevious)
      {
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,0,0,0,"SAR EA",10001,0,Green);
         if(ticket>0)
         {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES )) Print("BUY order opened : ",OrderOpenPrice());
         }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }

// Check for SELLS
    
         
 if(Close[1]<SARCurrent && Close[2] > SARPrevious)
      {
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,0,0,0,"SAR EA",20002,0,Red);
         if(ticket>0)
         {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES )) Print("SELL order opened : ",OrderOpenPrice());
         }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
         }
         return(0);
         }
//When should we close our position from above?

   for(cnt=0;cnt<total;cnt++)
   {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   
      if(OrderType()<=OP_SELL) // check for opened position 
         {


// If it's Buy position...
         if(OrderType()==OP_BUY)
         {
// Shall we close?
            if(Bid<SARCurrent)
               {
               OrderClose(OrderTicket(),OrderLots(),Bid,0,Violet) ; // close position
               return(0); // exit
               }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }              
         }


// If it's a Sell position...
         if(OrderType()==OP_SELL)
         {
// Shall we close?
           if(Bid>SARCurrent)
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,0,Violet) ; // close position
            return(0); // exit
            }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
         }
      }
} 


return(0);
}
//+------------------------------------------------------------------+